﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;

namespace ScorchedEarth
{
    public class MyDataContext
    {
        public ObservableCollection<Expression> Expressions { get; set; }
        public string CurrentExpression { get; set; }

        public MyDataContext()
        {
            List<Expression> defaultExpressions = new List<Expression>(4);
            Expression expression = new Expression();
            expression.Name = "Constant";
            Parameter param = new Parameter() {Name="C", Value=0.5f};
            expression.Parameters = new ObservableCollection<Parameter>() { param };
            expression.Statement = "height = C;";
            defaultExpressions.Add(expression);

            expression = new Expression();
            expression.Name = "Linear";
            param = new Parameter() {Name="Slope", Value=1.0f};
            Parameter param2 = new Parameter() {Name="B", Value=0.0f};
            expression.Parameters = new ObservableCollection<Parameter>() { param, param2 };
            expression.Statement = "height = Slope*x + B;";
            defaultExpressions.Add(expression);

            expression = new Expression();
            expression.Name = "Sin";
            param = new Parameter() {Name="Amplitude", Value=1.0f};
            param2 = new Parameter() {Name="Frequency", Value=3.141526f};
            Parameter param3 = new Parameter() {Name="Phase", Value=0.0f};
            expression.Parameters = new ObservableCollection<Parameter>() { param, param2, param3 };
            expression.Statement = "height = Amplitude*System.Math.Sin(Frequency*x+Phase);";
            defaultExpressions.Add(expression);

            Expressions = new ObservableCollection<Expression>(defaultExpressions);
        }
    }
}
